#!/usr/bin/perl

#script to add an order into the system
#written 29/2/00 by chris@katipo.co.nz


# Copyright 2000-2002 Katipo Communications
#
# This file is part of Koha.
#
# Koha is free software; you can redistribute it and/or modify it under the
# terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# Koha is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# Koha; if not, write to the Free Software Foundation, Inc., 59 Temple Place,
# Suite 330, Boston, MA  02111-1307 USA

use strict;
use CGI;
use C4::Output;
use C4::Catalogue;
use C4::Biblio;
#use Date::Manip;

my $input = new CGI;
my $existing=$input->param('existing');
my $title=$input->param('title');
$title=~ s/\'/\\\'/g;
my $author=$input->param('author');
$author=~ s/\'/\\\'/g;
my $copyright=$input->param('copyright');
my $isbn=$input->param('ISBN');
my $itemtype=$input->param('format');
my $ordnum=$input->param('ordnum');
my $basketno=$input->param('basket');
my $quantity=$input->param('quantity');
my $listprice=$input->param('list_price');
my $series=$input->param('Series');
if ($listprice eq ''){
  $listprice=0;
}
my $supplier=$input->param('supplier');
my $notes=$input->param('notes');
my $bookfund=$input->param('bookfund');
my $who=$input->remote_user;
my $bibnum;
my $bibitemnum;
my $rrp=$input->param('rrp');
my $ecost=$input->param('ecost');
my $gst=$input->param('GST');
my $orderexists=$input->param('orderexists');

if ($quantity ne '0'){
	#check to see if biblio exists
	if ($existing eq 'no'){
		#if it doesnt create it
		$bibnum = &newbiblio({ title     => $title?$title:"",
						author    => $author?$author:"",
						copyright => $copyright?$copyright:"",
						series => $series?$series:"",
							});
		$bibitemnum = &newbiblioitem({ biblionumber => $bibnum,
								itemtype     => $itemtype?$itemtype:"",
								isbn        => $isbn?$isbn:""
								});
			if ($title) {
				newsubtitle($bibnum,$title);
			}
	} else {
		$bibnum=$input->param('biblio');
		$bibitemnum=$input->param('bibitemnum');
		my $oldtype=$input->param('oldtype');
		if ($bibitemnum eq '' || $itemtype ne $oldtype){
			$bibitemnum= &newbiblioitem({ biblionumber => $bibnum,
									itemtype => $itemtype?$itemtype:"",
									isbn => $isbn?$isbn:"" });
		}
		&modbiblio({
			biblionumber  => $bibnum,
			title         => $title?$title:"",
			author        => $author?$author:"",
			copyrightdate => $copyright?$copyright:"",
			series        => $series?$series:"" });
	}
	if ($orderexists ne '') {
		modorder($title,$ordnum,$quantity,$listprice,$bibnum,$basketno,$supplier,$who,$notes,$bookfund,$bibitemnum,$rrp,$ecost,$gst);
	}else {
		neworder($bibnum,$title,$ordnum,$basketno,$quantity,$listprice,$supplier,$who,$notes,$bookfund,$bibitemnum,$rrp,$ecost,$gst);
	}
} else {
	$bibnum=$input->param('biblio');
	delorder($bibnum,$ordnum);
}

print $input->redirect("basket.pl?basket=$basketno");
